unit u_Main;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StrUtils, Clipbrd, JvComponent, JvAppHotKey, ShellApi, Menus, JvTrayIcon,
   ImgList, JvImageList, Registry, JvComponentBase, DB, MemDS, DBAccess,
   MyAccess, IniFiles, ExtCtrls, JvBalloonHint,
   ImageEnView, ievect, hyiedefs, hyieutils, gnugettext, imageenio,
   SSPIValidatePasswordW,
   u_ShBase, u_ShLowUtils, u_ShDbUtils, u_ShHighUtils, u_ttwvl;

const
   WM_HOTKEY_WVL_MESSAGE = WM_APP + 0;
   WM_HOTKEY_RECONNECT = WM_APP + 1; //3.5.0.39 [2393]

type
   Tfrm_Main = class (TForm)
      jtico_Main: TJvTrayIcon;
      pum_Main: TPopupMenu;
      mnu_Exit: TMenuItem;
      Strgs1: TMenuItem;
      Timer1: TTimer;
      MyConnection1: TMyConnection;
      MyQuery1: TMyQuery;
      JvBalloonHint1: TJvBalloonHint;
      ImageList1: TImageList;
      Viewer1: TMenuItem;
      tim_connect: TTimer;
      tim_5min: TTimer;
      procedure japp_HKHotKey(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure mnu_ExitClick(Sender: TObject);
      procedure Est1Click(Sender: TObject);
      procedure Timer1Timer(Sender: TObject);
      procedure pum_MainPopup(Sender: TObject);
      procedure Viewer1Click(Sender: TObject);
      procedure MyConnection1Error(Sender: TObject; E: EDAError; var Fail: Boolean);
      procedure tim_connectTimer(Sender: TObject);
      procedure jtico_MainDblClick(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
      procedure FormCreate(Sender: TObject);
      procedure tim_5minTimer(Sender: TObject);
    procedure japp_HKHotKeyRegisterFailed(Sender: TObject;
      var HotKey: TShortCut);
   protected
      fbconnecting: boolean;
      iGTaskCount, iGUsrID: integer;
      faj: array[0..10] of TJvApplicationHotKey;
      fsl: array[0..10] of String;
      fsa: array[0..10] of String;
      fbscreenshot: array[0..10] of Boolean;
      fbsearchlinks: array[0..10] of Boolean;
      shotkey: tshortcut;
      igRegTimIds: array of integer;
      gbshowpupup: boolean;
      twvlckeck: TTwvlcheck;
      fsdomain: string;
      fbbaloonactive: boolean;
      fiBaloonCounter: integer;
      fiBaloonCounterMax: integer;
      fUsername: string;
      procedure OnMyMessage(var Msg: TMessage); message WM_HOTKEY_WVL_MESSAGE;
      procedure OnReconnect(var Msg: TMessage); message WM_HOTKEY_RECONNECT; //3.5.0.3 [2393]
      procedure readtimidsfromregistry;
      procedure CreateParams(var Params: TCreateParams); override;
      procedure MYExit;
      procedure SetHint;
      function IsOptionWindowVisible: boolean;
      function TakeScreenshot(var bmp: TBitmap; MonitorNumber: Integer): Boolean;
      procedure FullScreen(var bmp: TBitmap; MonitorNumber: Integer);
   public
      // die werden von TTwvlcheck gebraucht
      gbhasreg, FormIsFullScreen, fbingetocrtext, fbtakescreenshot : boolean;
      fsOCR : string;
      procedure connnecttoserver;
      procedure getocrtext(bild : TBitmap);
      function ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string;
         Show: word; bWait: boolean): longint;
   end;

var
   frm_Main: Tfrm_Main;

implementation

uses u_dm_Main, u_Record, Myclasses, dateutils, u_screenshot;

{$R *.dfm}


procedure Tfrm_Main.MYExit;
begin
   Application.Terminate;
end;

// 15.09.2010 b.takacs
// If a window with caption: Optionen und Einstellungen is visible returns true else false
function Tfrm_Main.IsOptionWindowVisible: boolean;
var
	i: integer;
  found: boolean;
  WndHDL: cardinal;
  WndText: pchar;
begin
	found:= false;
  WndHDL:= GetWindow(handle,GW_HWNDFIRST);
  while (WndHDL<>GetWindow(handle,GW_HWNDLAST)) do
  begin
  	if (IsWindowEnabled(WndHDL) and (IsWindowVisible(WndHDL))) then
    begin
    	i:= GetWindowTextLength(WndHDL);
      GetMem(WndText, i+1);
      GetWindowText(WndHDL, WndText, i+1);
      if (StrPos(WndText,'Optionen und Einstellungen') <> nil) then
      begin
        found:= true;
      end;
      FreeMem(WndText);
    end;
    WndHDL:= GetWindow(WndHDL,GW_HWNDNEXT);
  end;
	result:= found;
end;


procedure Tfrm_Main.japp_HKHotKey(Sender: TObject);
var
   hWindow: HWND;
   Pid1, Pid2, lParam: cardinal;
   ksNew, ksOld: TKeyboardState;
   clip: TClipboard;
   lsparam, lsparam1, lsparam2, lssearch, FileName: string;
    Bmp: TBitmap;
begin
   if fbtakescreenshot then
    exit;

   if not IsOptionWindowVisible then //15.09.2010 b.takacs
	begin
   	try
         Pid1 := GetWindowThreadProcessId(Application.Handle);
         Pid2 := GetWindowThreadProcessID(GetForeGroundWindow);
         clip := TClipboard.Create;
         try
            if AttachThreadInput(Pid1, Pid2, True) then
            begin
               Bmp := TBitmap.Create;
               jtico_Main.IconIndex := 1;
               hWindow := GetFocus;
               lParam := MakeLong(0, MapVirtualKey($42, 0));
               ksNew[VK_CONTROL] := $80;
               GetKeyboardState(ksOld);
               SetKeyboardState(ksNew);
               PostMessage(hWindow, WM_KEYDOWN, integer($42), integer(lParam));
               PostMessage(hWindow, WM_KEYUP, integer($42), integer(lParam or $C0000000));

               Sleep(80);
               lsparam1 := '';
               lsparam2 := '';

               if fbscreenshot[(sender as TJvApplicationHotKey).Tag] then
               begin
                    fbtakescreenshot := True;
                    if TakeScreenshot(Bmp, 0) then
                    begin
                      {FileName := 'Screenshot_' +
                        FormatDateTime('mm-dd-yyyy-hhnnss', Now());
                      Bmp.SaveToFile(Format('D:\Test\%s.bmp', [FileName])); }
                      FullScreen(Bmp, 0);
                    end;
                    lssearch := fsOCR;
               end
               else
               begin
                 Application.ProcessMessages;
                 Sleep(800);
                 lssearch :=  Clip.AsText;
               end;
               if fsl[(sender as TJvApplicationHotKey).Tag] <> '' then
               begin
                  lsparam1 := ' "-L:' + fsl[(sender as TJvApplicationHotKey).Tag] + '"';
               end;
               if fsa[(sender as TJvApplicationHotKey).Tag] <> '' then
               begin
                  lsparam2 := ' "-A:' + fsa[(sender as TJvApplicationHotKey).Tag] + '"';
               end;

               if lssearch <> '' then
               begin
                 if fbsearchlinks[(sender as TJvApplicationHotKey).Tag] then
                   lsparam := '-R:' + #34 + lssearch + #34 + ' -GO'
                 else
                   lsparam := '-V:' + #34 + lssearch + #34 + ' ' + lsparam1 + lsparam2 + ' -GO';
                 ShellExecute(Application.Handle, PChar(''),
                    PChar(ExtractFilePath(ParamStr(0)) + 'viewerv3.exe'),
                    PChar(lsparam), nil, SW_Hide);
               end;

               SetKeyboardState(ksOld);
            end;

            //    Clip.Clear;
         finally
            fbtakescreenshot := False;
            AttachThreadInput(Pid1, Pid2, False);
            if Assigned(clip) then
               FreeAndNil(clip);
            if Assigned(Bmp) then
                Bmp.Free;
            jtico_Main.IconIndex := 0;
            jtico_Main.Animated := false;
         end;
      except
         on e:Exception do
            LogEvnt('Fehler bei japp_HKHotKey: ' + e.Message);
      end;
	end;
end;

procedure Tfrm_Main.FormShow(Sender: TObject);
var
   litime, licounter: integer;
begin
   fbtakescreenshot := False;
   fbconnecting := false;
   licounter := 1;
   BD.LogOn := false;
   while licounter <= paramcount do
   begin
      if pos('-time', paramstr(licounter)) > 0 then
      begin
         inc(licounter);
         trystrtoint(paramstr(licounter), litime);
         Timer1.interval := litime * 1000;
      end;
      if pos('-debug', paramstr(licounter)) > 0 then
      begin
         BD.LogOn := true;
      end;

      inc(licounter);
   end;
   GgfLogEvnt('HotSearch-Tfrm_Main.FormShow');


   (* m.frey: die Prfung setzt voraus, dass eine Connection da ist. Bei Hotsearch
   wird die connection nur vom Thread aufgemacht.
   
   if not PruefeProgrammversion('Hotsearch') then
      begin
         Application.Terminate;
         exit;
      end;
   *)


   gbshowpupup := true;
   ShowWindow(GetWindow(Handle, GW_OWNER), SW_HIDE);
   Left := 10000;
   while (not gbhasreg) do
   begin
      if twvlckeck = nil then
      begin
         // create thread
         twvlckeck := TTwvlcheck.Create(False);
      end
      else
      begin
         // demand terminate
         twvlckeck.terminate;
         // wait for terminate, it should just take the moment of a
         twvlckeck.waitfor;
         FreeAndNil(twvlckeck);
         twvlckeck := TTwvlcheck.Create(False);
      end;
      Application.ProcessMessages;
      sleep(200);
   end;
end;

procedure Tfrm_Main.mnu_ExitClick(Sender: TObject);
begin
   MYExit;
end;

procedure Tfrm_Main.Est1Click(Sender: TObject);
begin
   frm_Record.ShowModal;
end;

procedure Tfrm_Main.connnecttoserver;
var
   reg: tregistry;
   lsmycon, lsConnection, lsPassDb, lsPassIni, lsPassIniE, lsUsername: string;
   ini: TIniFile;
   icount: integer;
   lbLoginOk: boolean; // alles fr Anmeldung in Ordnung (Passwort und so ...)
begin
   Application.ProcessMessages;
   reg := TRegistry.Create;
   try
      reg.RootKey := HKEY_CURRENT_USER;
      reg.OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
      if reg.ValueExists('Conn') then
      begin
         lsmycon := reg.ReadString('Conn');
         lsConnection := ExtractFilePath(ParamStr(0)) + lsmycon + '.con';

         ini := TIniFile.Create(lsConnection);
         if (not (ini.ValueExists('Connection', 'Server')
            and ini.ValueExists('Connection', 'Port')
            and ini.ValueExists('Connection', 'User')
            and ini.ValueExists('Connection', 'DB')
            and ini.ValueExists('Connection', 'Pass')))
         then
         begin
            reg.CloseKey;
            gbhasreg := false;
            jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');
            exit;
         end;
         jtico_Main.Hint := _('Verbindung zum Server wird hergestellt.');
         gbhasreg := true;
         try
            myconnection1.Disconnect;
         except on e: Exception do
            begin
               myconnection1.Connected := false;
               exit;
            end;
         end;
         fsdomain := ini.ReadString('Connection', 'Domain', '');
         myconnection1.Server := ini.ReadString('Connection', 'Server', '');
         myconnection1.Port := ini.ReadInteger('Connection', 'Port', 3306);
         myconnection1.Database := ini.ReadString('Connection', 'DB', '');
         myconnection1.Username :=
            Decrypt(ini.ReadString('Connection', 'User', ' '), GlobalKey);
         myconnection1.Password :=
            Decrypt(ini.ReadString('Connection', 'Pass', ' '), GlobalKey);
         GgfLogEvnt('Server:' + myconnection1.Server +
               ';Db:' + myconnection1.Database);
         try
            myconnection1.Connect;
         except on e: Exception do
            begin
               jtico_Main.IconIndex := 1;
               jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');
               //could not connect to server
               for icount := 0 to 9 do
               begin
                  Application.ProcessMessages;
                  sleep(50);
               end;
               GgfLogEvnt('Error:' + e.message);
               gbhasreg := false;
               reg.CloseKey;
               exit;
            end;
            on e: EMyError do
            begin
               //showmessage('eeeor');
            end;
         end;
         ini.Destroy;
         if (not myconnection1.Connected) then
         begin
            gbhasreg := false;
            reg.CloseKey;
            exit;
         end;
         ini := TIniFile.Create(PChar(GetSystemVariable('APPDATA') +
            '\bitfarm-archiv' + '\mylogin.ini'));

         (* v3.5.0.9
            auskommentiert und neugebaut, wegen MVB
            Der HotSearch brauch nur den Usernamen, keine Anmeldung
            Es reicht, dass der Viewer eine Anmeldung bentigt
            28.05.2010  f.schneider

         if ((ini.ValueExists('User', 'UserName')) and
            (ini.ValueExists('User', 'Password'))) then
         begin
            lsUsername := ini.ReadString('User', 'UserName', '');
            fUsername := lsUsername;
            myquery1.SQL.Text := 'select * from sys_usr where Usr_Name = ' + #34 + lsUsername + #34;
            myquery1.Execute;
            GgfLogEvnt('User:' + myquery1.FieldByName('Usr_Name').AsString);
            lsPassDb := myquery1.FieldByName('usr_pass').AsString; // das Passwort in der bitfarm-Datenbank
            lsPassIni := ini.ReadString('User', 'Password', '');
            if ( (lsPassDb <> lsPassIni )
            or (myquery1.RecordCount = 0))
            then
            begin
               lsPassIniE:=DeCrypt(lsPassIni, GlobalKey);
               //try to login with ldap
               try
                  if (lsPassIniE='') // Passwort muss bei AD angegegben werden
                  then lbLoginOk := false // SSPLogonUser liefert bei leerem PW true!
                  else lbLoginOk := SSPLogonUser(fsdomain, lsUsername, lsPassIniE);
               except
                  lbLoginOk := false;
               end;
            
               if not lbLoginOk then
               begin
                  jtico_Main.Hint := 'Benutzername oder Passwort falsch, Wvl kann nicht berprft werden.';
                  gbhasreg := false;
                  reg.CloseKey;
                  exit;
               end;
            end;
            iGUsrID := myquery1.FieldByName('usr_id').asinteger;
            reg.CloseKey;
            readtimidsfromregistry;
         end
         else
         begin
            gbhasreg := false;
            reg.CloseKey;
            exit;
         end;
         *)
         //v3.5.0.9 f.schneider
         if (ini.ValueExists('User', 'UserName')) then
         begin
            lsUsername := ini.ReadString('User', 'UserName', '');
            fUsername := lsUsername;
            myquery1.SQL.Text := 'select * from sys_usr where Usr_Name = ' + #34 + lsUsername + #34;
            myquery1.Execute;
            GgfLogEvnt('User:' + myquery1.FieldByName('Usr_Name').AsString);
            if  myquery1.RecordCount = 0 then
            begin
              gbhasreg := false;
              reg.CloseKey;
              exit;

            end;
            iGUsrID := myquery1.FieldByName('usr_id').asinteger;
            reg.CloseKey;
            readtimidsfromregistry;
         end;
         //v3.5.0.9 f.schneider
         
      end
      else
      begin
         gbhasreg := false;
      end;
   finally
      reg.CloseKey;
      SetHint;
   end;
end;

procedure Tfrm_Main.readtimidsfromregistry;
var
   reg: tregistry;
   icount: integer;
begin
   try
      reg := TRegistry.Create;
      reg.RootKey := HKEY_CURRENT_USER;
      reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\wvl', True);
      if reg.ValueExists('iGTaskCount') then
      begin
         iGTaskCount := reg.ReadInteger('iGTaskCount');

         setlength(igRegTimIds, iGTaskCount);
         for icount := 0 to iGTaskCount - 1 do
         begin
            if reg.ValueExists('tim_id' + IntToStr(icount)) then
               igRegTimIds[icount] := reg.ReadInteger('tim_id' + IntToStr(icount))
            else
               igRegTimIds[icount] := -1;
         end;
      end;
      reg.CloseKey;

   finally
      begin
         if assigned(reg) then
         begin
            reg.CloseKey;
            freeandnil(reg);
         end;
      end;
   end;
end;


procedure Tfrm_Main.Timer1Timer(Sender: TObject);
var
   i, icount, iCount1, iDiff, iGYear, iGKW, liTimId: integer;
   bEmpty, bFound, lbDo: bool;
   iPos: TPoint;
   irect: Trect;
   dtFirstDayOfKW, dtStart, dtEnd, dtDate: TDateTime;
   sStart, sEnd, sLogReg, sLogSql, lsLog: string;
begin
   if (not gbhasreg) or fbconnecting then
   begin
      exit;
   end;
   if (not myconnection1.Connected) then
   begin
      Timer1.Enabled := false;
      tim_connect.Enabled := true;
      Exit;
   end;

   // Werte werden nur einmal geholt, weil die sich ja ndern knnen; das ist zwar
   // sehr unwahrscheinlich aber besser so
   if paramstr(1)='-KW53' // nur fr Testzwecke
   then dtDate := EncodeDateTime(2009,12,30,0,0,0,0)
   else dtDate := date;

   // einige aktuellen Daten bestimmen
   iGYear := YearOf(dtDate);
   iGKW := WeekOf(dtDate);
   dtFirstDayOfKW := EncodeDateWeek(iGYear, iGKW, 1);
   //m.frey: das Folgende ist doch nutzlos? ...
   dtStart := StartOfTheWeek(dtFirstDayOfKW);
   dtEnd := EndOfTheWeek(dtFirstDayOfKW);
   DateTimeToString(sStart, 'yyyy-mm-dd hh:nn:ss', dtStart);
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', dtEnd);
   //m.frey: ... weil hier wird sStart und sEnd erneut bestimmt
   dtStart := StartOfTheWeek(dtDate);
   dtEnd := EndOfTheWeek(dtDate);
   DateTimeToString(sStart, 'yyyy-mm-dd hh:nn:ss', dtStart);
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', dtEnd);
   sStart := AddQuote(sStart);  sEnd := AddQuote(sEnd);
   //Abfrage der Datenbank nach ... ???
   myquery1.SQL.Text := 'Select tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_name,' +
      'arc_tblname, doc_id, doc_titel, info, optionen, status, usr_id_work, usr_id_shed ' +
      'from sys_timer ' +
      'left join sys_arc using(arc_id) ' +
      'where ' +
      'usr_id_work = ' + IntToStr(iGUsrID) +
      ' and status <> 2 and ' +
      '((Termin between ' + sStart + ' and ' + sEnd + ') or ' + ' (Termin < ' + sStart + ')) ' +
      'order by termin ' +
      'limit 1000';
   (*m.frey:
   1. Mssen die Werte sortiert sein? MySql verwendet dann ungnstigerweise filesort

   2. Es gibt da bei where den Ausdruck z.B.:
   '((Termin between '2010-01-18 00:00:00' and '2010-01-24 23:59:59') or  (Termin < '2010-01-18 00:00:00'))'

   3. Brauchen wir folgende Felder?
      arc_tblname, doc_id, doc_titel, info, optionen, usr_id_shed und letzlich die ganze sys_arc?
   *)

   //mal weg GgfLogEvnt('Query:' + myquery1.SQL.Text);
   try
      myquery1.Open;
      myquery1.First;
   except on e: Exception do
      begin
         myconnection1.Connected := false;
         exit;
      end;
   end;
   iDiff := 0;

   // should check for changes also!!!
   // maybe the viewer should save directly to registry any changes...
   if (myquery1.RecordCount = 0) and (iGTaskCount <> 0)
   then
   begin
      //The list is empty so no blink!!!
      bFound := False;
      bEmpty := true;
   end
   else
   begin
      bEmpty := true;
      bFound := false;
      if iGTaskCount <> myquery1.RecordCount then
      begin
         bEmpty := false;
         bFound := false;
      end
      else
      begin
         for icount := 0 to myquery1.RecordCount - 1 do //wre da nicht ein "while myquery1.eof do" besser?
         begin
            bFound := false;
            //vorher mal holen, muss nicht in der folgenden Schleife sein.
            liTimId := myquery1.FieldByName('tim_id').AsInteger;
            //
            for iCount1 := 0 to iGTaskCount - 1 do
            begin
               bEmpty := false;
               if igRegTimIds[icount1] = liTimId then
               begin
                  bFound := True;
                  break;
               end;
            end;

            if not bFound then
            begin
               iDiff := iDiff + 1;
            end
            else
            begin
               bFound := true;
            end;

            myquery1.Next;
         end;
      end;
   end;

   if BD.LogOn then
   begin
      sLogReg := '';
      for i := 0 to iGTaskCount - 1 do
      begin
         sLogReg := sLogReg + IntToStr(igRegTimIds[i]) + ',';
      end;

      sLogSql := '';
      myquery1.First;
      for icount := 0 to myquery1.RecordCount - 1 do
      begin
         sLogSql := sLogSql + myquery1.FieldByName('tim_id').AsString + ',';
         myquery1.Next;
      end;

      if sLogReg=sLogSql then
         lsLog := ' Reg=SQL'
      else
         lsLog := '';

      GgfLogEvnt('rc:' + inttostr(myquery1.RecordCount) + ';tc:' + inttostr(iGTaskCount) +
            ';f:' + booltostr(bFound) + ';dif:' + inttostr(iDiff) +
            ';em:' + booltostr(bEmpty) + lsLog);
   end;

   lbDo := ((not bFound) or (iDiff <> 0)) and (not bEmpty);
   if lbDo then
   begin
      if BD.LogOn then
      begin
         if sLogReg<>sLogSql
         then
         begin
         GgfLogEvnt('Reg:'+sLogReg);
         GgfLogEvnt('SQL:'+sLogSql);
         end
      end;

      setlength(igRegTimIds, 0);
      setlength(igRegTimIds, myquery1.RecordCount);

      myquery1.First;
      for icount := 0 to myquery1.RecordCount - 1 do
      begin
         igRegTimIds[icount] := myquery1.FieldByName('tim_id').AsInteger;
         myquery1.Next;
      end;

      iGTaskCount := myquery1.RecordCount;
      GgfLogEvnt('hotsearch start blinkt');
      jtico_Main.Animated := true;
      if iDiff <> 0 then
      begin
         jtico_Main.Delay := trunc((700 / (iDiff)) + 100);
      end
      else
      begin
         jtico_Main.Delay := trunc((700 / (1)) + 100);
      end;
      jtico_Main.GetIconRect(irect);
      ipos := irect.TopLeft;
      JvBalloonHint1.ActivateHintPos(nil, ipos, _('Wiedervorlageliste-nderung'),
                               _('Ihre Wiedervorlageliste hat sich gendert.'));
      fiBaloonCounter := 0;
      tim_5min.enabled := fbbaloonactive;
   end;
end;

procedure Tfrm_Main.pum_MainPopup(Sender: TObject);
begin
   jtico_Main.Animated := false;
   jtico_Main.IconIndex := 0;
end;

procedure Tfrm_Main.Viewer1Click(Sender: TObject);
var lsParam, lsCmd: string;  h:THandle;
   aparameter,
   lsprogname, lstmp, lsCaption, lsRepos, lsLog: string;
   lirueck, licounter, lireturncode: integer;
   lirev: int64;
   si: TStartupInfo;
   pi: TProcessInformation;
begin
   jtico_Main.Animated := false;
   Application.ProcessMessages;

   lsParam := '';
   if (      (GetKeyState(vk_Control)<0) //GetShiftState
         and (GetKeyState(vk_Shift)<0) //GetShiftState
      )
   or BD.LogOn
   then lsParam := '-debug';

   //lsCmd := ExtractFilePath(ParamStr(0)) + 'viewerv3.exe'+lsParam;
   lsCmd := ExtractFilePath(ParamStr(0)) + 'viewerv3.exe';

   GgfLogEvnt('Tfrm_Main.Viewer1Click lsCmd="'+lsCmd+'" lsParam="'+lsParam+'"');

   //h := Application.Handle;
   h := GetDesktopWindow;  //3.5.0.40 [2336]
   //ShellExecute(Application.Handle, PChar(''), PChar(lsCmd), nil, PChar(''), 0);
   //ShellExecute(h, PChar(''), PChar(lsCmd), PChar(lsParam), PChar(''), 0);

   (**********************)
   FillChar(si, SizeOf(si), 0);
   si.cb         := SizeOf(si);
   si.dwFlags    := STARTF_USESHOWWINDOW;
   si.wShowWindow:= SW_hide;
   FillChar(pi, SizeOf(pi), 0);
   AParameter := Format('cmd /c %s', [TrimRight(lsCmd)]);
   {errb := }CreateProcess(nil, PChar(Aparameter), nil, nil,
      longbool(False), CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
      nil, PChar(BD.ExeDir), si, pi);

   Sleep(3000);
   TerminateProcess(pi.hProcess, 0);
   CloseHandle(pi.hProcess);
   CloseHandle(pi.hThread);
end;

(*
procedure Tfrm_Main.Viewer1Click(Sender: TObject);
var
   parameter, aparameter,
   lsprogname, lstmp, lsCaption,lsRepos: string;
   lirueck, licounter, lireturncode: integer;
   lirev: int64;
   si: TStartupInfo;
   pi: TProcessInformation;
begin
   jtico_Main.Animated := false;
   Application.ProcessMessages;
   FillChar(si, SizeOf(si), 0);
   si.cb := SizeOf(si);
   si.dwFlags := STARTF_USESHOWWINDOW;
   si.wShowWindow := SW_hide;
   FillChar(pi, SizeOf(pi), 0);
   //    cmd:= 'shell32.dll,OpenAs_RunDLL %s';
   parameter := 'F:\Programme\Borland\Delphi7\Projects\Archiv-svn\Delphi\branch\V3.5\ViewerV3\viewerv3.exe';
   AParameter := Format('cmd /c %s', [TrimRight(parameter)]);
   {errb := }CreateProcess(nil, PChar(Aparameter), nil, nil,
      longbool(False), CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
      nil, PChar(BD.ExeDir), si, pi);
end;
*)

procedure Tfrm_Main.MyConnection1Error(Sender: TObject; E: EDAError; var Fail: Boolean);
var icount: integer;
begin
   jtico_Main.IconIndex := 1;
   jtico_Main.Hint := _('Es konnte keine Verbindung zum Server hergestellt werden.');

   // Application.ProcessMessages;
   //could not connect to server
   for icount := 0 to 9 do
   begin
      Application.ProcessMessages;
      sleep(50);
   end;
end;


procedure Tfrm_Main.tim_connectTimer(Sender: TObject);
begin
   if fbconnecting then
      exit;
   fbconnecting := true;
   try
      connnecttoserver;
   except on e: Exception do
      begin
      end;
   end;
   fbconnecting := false;
   if myconnection1.Connected then
   begin
      jtico_Main.IconIndex := 0;
      (*
      jtico_Main.Hint := 'bitfarm HotSearch Tool (STRG+C) + (STRG+B)' + #13 +
                         'Benutzer:'+fUsername;
      *)
      SetHint;
      tim_connect.Enabled := false;
      Timer1.Enabled := true;
   end;
end;

procedure Tfrm_Main.jtico_MainDblClick(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   jtico_Main.Animated := false;
   jtico_Main.IconIndex := 0;
   Application.ProcessMessages;

   ShellExecute(Application.Handle, PChar(''),
      PChar(ExtractFilePath(ParamStr(0)) + 'viewerv3.exe'),
      pchar(' -W:'), PChar(''), 0);
end;

procedure Tfrm_Main.OnMyMessage(var Msg: TMessage);
begin
   if msg.WParam = 1 then
   begin
      //wvl activated stop blinking
      jtico_Main.Animated := false;
      jtico_Main.IconIndex := 0;
      JvBalloonHint1.CancelHint;

      tim_5min.enabled := false;
      readtimidsfromregistry;
   end;
end;

//3.5.0.3 [2393]
procedure Tfrm_Main.OnReconnect(var Msg: TMessage);
begin
   GgfLogEvnt('Tfrm_Main.OnReconnect');
   myconnection1.Disconnect;
   connnecttoserver;
end;

procedure Tfrm_Main.CreateParams(var Params: TCreateParams);
begin
   inherited;
   StrCopy(Params.WinClassName, 'bitfarm.hotsearch.V3');
end;

procedure Tfrm_Main.FormCreate(Sender: TObject);
var
   reg: Tregistry;
   li: integer;
   ls: string;
begin
   u_ShDbUtils.my_Con := Self.MyConnection1;
   BD.LogPath := BD.EnvTemp;
   BD.LogName := 'HotSearch.log';
   //GnugettextTextdomain('HotSearchV3', 'd:\Enterprise-3.5\Delphi-3.5\', 'en');
   TP_GlobalIgnoreClassProperty(Tfrm_Main,'Caption');
   GnugettextTextdomain('HotSearchV3', '', '');
   TranslateComponent(Self, 'HotSearchV3');
   reg := Tregistry.create;
   try
      //japp_HK := TJvApplicationHotKey.Create(self);
      //japp_HK.Active := false;
      reg.RootKey := HKEY_CURRENT_USER;
      // Einlesen der Options-Einstellungen
      reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
      // Auf Index 0 liegt der Standard-Hotkey STRG + B
      //if reg.ValueExists('HotsearchHK') then
      //   japp_HK.hotkey := reg.Readinteger('HotsearchHK');
      faj[0] := TJvApplicationHotKey.Create(self);
      faj[0].hotkey := 16450;
      if reg.ValueExists('HotsearchHK') then   //mittels dem Eintrag HotsearchHK kann man den Standard
         faj[0].hotkey := reg.Readinteger('HotsearchHK');     // STRG + B umdefinieren

      faj[0].Active := true;
      faj[0].OnHotKey := japp_HKHotKey;
      faj[0].OnHotKeyRegisterFailed := japp_HKHotKeyRegisterFailed;
      faj[0].Tag := 0;
      fsl[0] := '';
      fsa[0] := '';
      fbscreenshot[0] := False;
      fbsearchlinks[0] := False;

      // ab Index 1 kommen die 10 optionalen HK des Viewers
      for li := 1 to 10 do
      begin
         if reg.ValueExists('HotsearchHK' + inttostr(li - 1)) then
         begin
            faj[li] := TJvApplicationHotKey.Create(self);
            faj[li].hotkey := reg.Readinteger('HotsearchHK' + inttostr(li - 1));
            if faj[li].HotKey = faj[0].HotKey then  //wenn STRG + B im Viewer umkonfiguriert wird
               faj[0].Active := False;

            faj[li].Active := true;
            faj[li].OnHotKey := japp_HKHotKey;
            faj[li].Tag := li;
         end;
      end;
      if reg.ValueExists('HotSearchBallonTimes') then
         fiBaloonCounterMax := reg.Readinteger('HotsearchHK')
      else
         fiBaloonCounterMax := -1;
      if reg.ValueExists('HotSearchBallonActivated') then
         fbbaloonactive := reg.ReadBool('HotsearchHK')
      else
         fbbaloonactive := true;
      reg.CloseKey;

      if reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen\Hotsearch', False) then
      begin
         for li := 1 to 10 do
         begin
            ls := inttostr(li - 1);
            if reg.valueexists('StdLgr' + ls) then
               fsl[li] := reg.ReadString('StdLgr' + ls)
            else
               fsl[li] := '';
            if reg.valueexists('StdArc' + ls) then
               fsa[li] := reg.ReadString('StdArc' + ls)
            else
               fsa[li] := '';
            if reg.valueexists('UseScreenshot' + ls) then
               fbscreenshot[li] := reg.ReadBool('UseScreenshot' + ls)
            else
               fbscreenshot[li] := false;
            if reg.valueexists('SearchLinks' + ls) then
               fbsearchlinks[li] := reg.ReadBool('SearchLinks' + ls)
            else
               fbsearchlinks[li] := false;
         end;
         reg.CloseKey;
      end;

   finally
      if assigned(reg) then
         reg.Free;
      //japp_HK.Active := true;

      (*
      jtico_Main.Hint := 'bitfarm HotSearch Tool (STRG+C) + (' +
         shortcuttotext(japp_HK.hotkey) + ')' + #13 +
         'Benutzer:'+fUsername;
      *)
      SetHint;
   end;
end;

procedure Tfrm_Main.tim_5minTimer(Sender: TObject);
var
   irect: Trect;
begin
   if fiBaloonCounterMax > 0 then
   begin
      if fiBaloonCounter > fiBaloonCounterMax then
      begin
         tim_5min.enabled := false;
      end;
   end;
   jtico_Main.GetIconRect(irect);

   JvBalloonHint1.ActivateHintPos(nil, irect.TopLeft, _('Wiedervorlageliste-nderung'),
                               _('Ihre Wiedervorlageliste hat sich gendert.'));

   inc(fiBaloonCounter);
end;

//-----------------------------------------------------------------------------
procedure Tfrm_Main.SetHint;
begin
   if fUsername=''
   then Exit;
   jtico_Main.Active := False;
   jtico_Main.Hint := _('bitfarm HotSearch Tool (STRG+C) + (') +
      shortcuttotext(faj[0].hotkey) + ')' + ' ' +
      _('Benutzer:')+fUsername;           // m.frey: funzt iwie nicht
   jtico_Main.Active := True;
end;

procedure Tfrm_Main.FullScreen(var bmp: TBitmap; MonitorNumber: Integer);
var
  pos : TPosition;
begin
	try
     Form2 := TForm2.Create(frm_Main);
     Form2.BorderStyle := bsNone;
     Form2.WindowState := wsNormal;
     Form2.Scaled := False;
     Form2.BorderIcons := [];
     Form2.DefaultMonitor := dmDesktop;

     if (MonitorNumber = 0) then begin

         Form2.BoundsRect :=  Screen.DesktopRect;
         Form2.Image1.Picture.Bitmap.Width := Screen.DesktopWidth;
         Form2.Image1.Picture.Bitmap.Height := Screen.DesktopHeight;
         Form2.Image1.Width := Screen.DesktopWidth;
         Form2.Image1.Height := Screen.DesktopHeight;

     end else begin

         Form2.BoundsRect :=  Screen.Monitors[MonitorNumber-1].BoundsRect;
         Form2.Image1.Picture.Bitmap.Width := Screen.Monitors[MonitorNumber-1].Width;
         Form2.Image1.Picture.Bitmap.Height := Screen.Monitors[MonitorNumber-1].Height;
         Form2.Image1.Width := Screen.Monitors[MonitorNumber-1].Width;
         Form2.Image1.Height := Screen.Monitors[MonitorNumber-1].Height;
     end;
     Form2.Image1.Picture.Assign(bmp);
     Form2.ShowModal;
   except
      on e:Exception do
      	LogEvnt('Fehler bei FullScreen: ' + e.Message);

   end;
end;


function Tfrm_Main.TakeScreenshot(var bmp: TBitmap; MonitorNumber: Integer): Boolean;
const
  CAPTUREBLT = $40000000;
var
  DesktopCanvas: TCanvas;
  DC: HDC;
  Left, Top: Integer;
begin
  Result := False;
  if (MonitorNumber > Screen.MonitorCount) then
  	Exit;
  DC:= GetDC(0);
  try
    if (DC = 0) then
    	Exit;
    try
       if (MonitorNumber = 0) then begin
         Bmp.Width := Screen.DesktopWidth;
         Bmp.Height := Screen.DesktopHeight;
         Left := Screen.DesktopLeft;
         Top := Screen.DesktopTop;
       end
       else
       begin
         Bmp.Width := Screen.Monitors[MonitorNumber-1].Width;
         Bmp.Height := Screen.Monitors[MonitorNumber-1].Height;
         Left := Screen.Monitors[MonitorNumber-1].Left;
         Top := Screen.Monitors[MonitorNumber-1].Top;
       end;
    except
    	on e:Exception do
      	LogEvnt('Fehler bei TakeScreenshot: Zuweisung der Bildschirmgre ' + e.Message);

    end;

    try
       DesktopCanvas := TCanvas.Create;
       try
         DesktopCanvas.Handle := DC;
         Result := BitBlt(
           Bmp.Canvas.Handle,
           0,
           0,
           Bmp.Width,
           Bmp.Height,
           DesktopCanvas.Handle,
           Left,
           Top,
           SRCCOPY or CAPTUREBLT
         );
         Result:= True;
       finally
         DesktopCanvas.Free;
       end;
    except
    	on e:Exception do
      	LogEvnt('Fehler bei TakeScreenshot: Screenshot erstellen' + e.Message);

    end;
  finally
    if (DC <> 0) then
    ReleaseDC(0, DC);
  end;
end;

procedure Tfrm_Main.getocrtext(bild : TBitmap);
var
   im: TImageEnVect;
   lsdocname, lsoutput, lsErgebnis: string;
   lst1: Tstringlist;
   li, lipos1, lipos2, lipos3: integer;
   reg: TRegistry;
   vResult: Cardinal;
   lbnocr: boolean;
   lsCmd1, lsCmd2: string;
begin
   OutputDebugString('getocrtext beg');

   if fbingetocrtext then
   begin
      ShowMessage(_('OCR ist bereits in Benutzung, bitte warten Sie einige Sekunden ') + #13 +
         _('und versuchen Sie erneut.'));
      exit;
   end;
   try
      try
         fbingetocrtext := true;
         try
            im := TImageEnVect.Create(nil);
            //im.IO.AutoAdjustDPI:= true; //13.04.2011 b.takacs 3.5.0.176 [2891]
            im.Bitmap.PixelFormat := pf24bit;
            im.Width := bild.Width;
            im.Height := bild.Height;
            im.Bitmap.Canvas.Brush.Style := bsSolid;
            im.Bitmap.Canvas.FillRect(Rect(0,0,bild.Width,bild.Height));
            //im.BitmapResampleFilter := rfLinear;
            im.Bitmap.Assign(bild);
            //im.Proc.ImageResize(im.Width * 2, im.Height * 2, iehLeft, ievTop);
            //im.IO.SaveToFile(BD.EnvTemp + '\temp3.ppm');
            //im.Proc.Resample(im.Width * 3, im.Height * 3, rfLinear);
            im.IO.Params.TIFF_Compression := ioTIFF_LZW;
            lsdocname := BD.EnvTemp + '\hotsearch.tif';
            im.IO.SaveToFileTIFF(lsdocname);
         finally
            if assigned(im) then
               FreeAndNil(im);
         end;

         lsoutput := lsdocname;

         lsCmd1 := BD.ExeDir + 'bfa_tessocr.exe';
         OutputDebugString(PChar('getocrtext lsCmd1='+lsCmd1));
         if fileexists(lsCmd1) then
         begin
            ShellExecute_AndWait('',
               lsCmd1, '"' + lsdocname + '"  "' + lsoutput + '"' + ' --outformat txt --pbstring "" --overwrite',
               BD.EnvTemp, SW_HIDE, True);
            lbnocr := true;
         end;

         OutputDebugString(PChar('getocrtext lsoutput='+lsoutput));
         fsOCR := '';
         lst1 := Tstringlist.create;
         if FileExists(lsoutput + '.txt') then
           lst1.LoadFromFile(lsoutput + '.txt');
         fsOCR := lst1.Text;

         DeleteFile(lsdocname);
         DeleteFile(lsoutput + '.txt');

      except on e: exception do
         begin
            LogEvnt('Fehler bei getocrtext');
            OutputDebugString('error on dm_MainForm2.getocrtext ');
         end;
      end;
   finally
      fbingetocrtext := false;
      If Assigned(lst1) then
        FreeAndNil(lst1);

      Form2.Close;
   end;


   OutputDebugString('getocrtext end');
end;


function Tfrm_Main.ShellExecute_AndWait(Operation, FileName,
   Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
   bOK: boolean;
   Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
   FillChar(Info, SizeOf(Info), Chr(0));
   Info.cbSize := SizeOf(Info);
   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
   Info.lpVerb := PChar(Operation);
   Info.lpFile := PChar(FileName);
   Info.lpParameters := PChar(Parameter);
   Info.lpDirectory := PChar(Directory);
   Info.nShow := Show;
   bOK := boolean(ShellExecuteEx(@Info));
   if bOK then
   begin
      if bWait then
      begin
         while
            WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
            Application.ProcessMessages;
         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      end
      else
         Result := 0;
   end;
   if not bOK then
      Result := -1;
end;



procedure Tfrm_Main.japp_HKHotKeyRegisterFailed(Sender: TObject;
  var HotKey: TShortCut);
begin
  OutputDebugString('failed');
end;

end.
